<?php

/*------------------------------------------------------------------------
# Copyright (C) 2015-2016 WebxSolution Ltd. All Rights Reserved.
# @license - GPLv2.0
# Author: WebxSolution Ltd
# Websites:  http://www.webxsolution.com
# Terms of Use: An extension that is derived from the JoomlaCK editor will only be allowed under the following conditions: http://joomlackeditor.com/terms-of-use
# ------------------------------------------------------------------------*/ 

defined('_JEXEC') or die;

/**
 *Ark inline content  System Plugin
 *
 * @package     Joomla.Plugin
 * @subpackage  System.inlineContent
  */

error_reporting(E_ERROR);

class PlgSystemArkFme extends JPlugin
{
	public $app, $options = array(),$lists = array();
	private $_content = '';
	private $_returnPage = '';
    private $_defaultReturnPage = '';
    public  $helpURL = '';
    public  $items = 0;

	/**
	 * Constructor
	 */
	public function __construct( &$subject, $config )
	{
		// Load plugin language
		JFactory::getLanguage()->load( 'plg_system_arkfme', JPATH_ADMINISTRATOR );

		parent::__construct( $subject, $config );
	}//end function

	public function onAfterRoute()
	{
				
		if ($this->app->isAdmin() )
		{
			return;
		}
			
		$user = JFactory::getUser();
                
        //if user is guest lets bail
		if($user->get('guest'))
		{
			return;
		}

		// Don't load in Ark Media as there is JS that breask AM
		if( $this->app->input->get('option') === 'com_arkmedia' )
		{
			return;	
		}//end if

        if($this->app->input->get('option') == 'com_content' && $this->app->input->get('view') == 'form')
		{	
            
            $session = JFactory::getSession();
            if($session->get('ARK.fme.return',''))
            {
               $this->app->input->set('return', $session->get('ARK.fme.return'));
            } 		
        }

		$type = $this->app->input->get('type','','BASE64');
		
		//get menutype options
		$options = (array) $this->getTypeOptionsFromLayouts('com_content','article');
		$options = array_merge($options, (array) $this->getTypeOptionsFromLayouts('com_content', 'category'));
		$this->options = $options;

 	    JHTML::addIncludePath(JPATH_PLUGINS. '/system/arkfme/assets/html');
		
		
		$lang = JFactory::getLanguage();


        $articleId = $this->app->input->get('a_id',0);

        $menuitemid = NULL;

        $needles = NULL;

        $session = Jfactory::getSession();

        if(!$articleId)
        {
              if($session->get('ark_a_id',0) && $this->app->input->get('option') == 'com_arkfme') 
              {
                $this->app->input->set('a_id',$session->get('ark_a_id'));
                $articleId = $this->app->input->get('a_id');
              }
        }
			
		if($articleId)
		{	
			$article = JTable::getInstance('content');
			$article->load($articleId);
				
			$needles = array(
				'article'  => (int) $articleId, // only deal with single article Menu Item for now
				'category' => (int) $this->app->input->get('catid',$article->catid )// fallback to see if category has menu
			);	
		
           $session->set('ark_a_id',$articleId);
       
        }


		if(!$type) //We default to single article menu item type
		{	
			$type = new JObject;
			$obj = new stdclass;
     			
			$file = JPATH_SITE . '/components/com_content/views/article/tmpl/default.xml';
			$obj->title ='Article';
			$obj->description = '';
			
			$obj->request = array('option' => 'com_content', 'view' => 'article');
			$obj->type = 'component';
			
			$menuitemid = $this->_findMenuItem($needles);

 
			$menuitemid =  is_null($menuitemid) ?  0 :  $menuitemid;
			
      

			if($menuitemid)
			{
				$item = $this->getItem($menuitemid);
          	    $obj->request = $item->request;
			}	
			
			$this->app->input->set('menuitem', $menuitemid);
			
			if(is_file($file))
			{	
				if ($xml = simplexml_load_file($file))
				{	
					if ($menu = $xml->xpath('layout[1]'))
					{
							$menu = $menu[0];
							if (!empty($menu['title']))
							{
								$obj->title = trim((string) $menu['title']);
							}

							if (!empty($menu->message[0]))
							{
								$obj->description = trim((string) $menu->message[0]);
							}
					}
				}
			}
		
			//implemetation TODO
			$input = $this->app->input;

            $this->app->input->set('menuitemid', is_null($menuitemid) ? 0 : $menuitemid );
			
			$input->set('title',$obj->type);
			$input->set('link','index.php?'.JURI::buildQuery((array) $obj->request));
				
			//fake one for testing
            
            $obj->request['id'] = $articleId;    


			$this->type = base64_encode(json_encode($obj)); 
			
			
			// Load the system language file for the component.
			$lang->load($obj->request['option'].'.sys', JPATH_ADMINISTRATOR, null, false, true)
			|| $lang->load($obj->request['option'].'.sys', JPATH_ADMINISTRATOR . '/components/' . $obj->request['option'], null, false, true);
			
			// Load the language file for the component.
			$lang->load($obj->request['option'], JPATH_ADMINISTRATOR, null, false, true)
			|| $lang->load($obj->request['option'], JPATH_ADMINISTRATOR . '/components/' . $obj->request['option'], null, false, true);
				
		
			if(isset($obj->request['id']))
				unset($obj->request['id']);	

  			$this->lists['menutypes'] = JHTML::_('ark.menu.types',$this->options,'arktype', null,'value', 'text', array('request'=>$obj->request), false, true);  
			
            
            $menuitems = $this->_findMenuItems($needles);

           
            $this->items = $menuitems;

            $this->lists['menuitems'] = JHTML::_('select.genericlist',$menuitems,'menuitem','','id','text', $this->app->input->get('menuitem',0));


			$this->_content = JLayoutHelper::render('joomla.arkfme.offcanvas', $this);
						
		}
		else
		{
			$obj = json_decode(base64_decode($type,true));

			if(empty($obj))
			{
				$menuitemid = $this->_findMenuItem($needles);
				$item = $this->getItem($menuitemid);
                $obj =  new stdclass;        
                $obj->request = $item->request;
			}	
			elseif(!isset($obj->request))
			{
				
			    if($this->app->input->get('catid',0))
				{
					$obj2 = new stdclass;
					$obj2->request = (array) $obj;
					
				                   
                    $needles = array(
						'article'  => (int) $articleId, // only deal with single article Menu Item for now
						'category' => (int) $this->app->input->get('catid') // fallback to see if category has menu
					);
					
         
                    $menuitemid = $this->_findMenuItem($needles);
                    
                    $id = (int) $this->app->input->get('menuid',0);
					
                    if(!is_null($menuitemid) && $menuitemid != $id)
					{	
						$item = $this->getItem($menuitemid);
						$obj2->request = $item->request;
					}
					$obj = $obj2;
				}
				else
				{	
                   
                    $obj2 = new stdclass;
					$obj2->request = (array) $obj;
                     $menuitemid = $this->app->input->get('menuid',0);
					$obj2->type = 'component';
					$obj = $obj2;
                    if( $this->app->input->get('action','') != 'type')
                    {
                        $item = $this->getItem($menuitemid);
 				        $obj->request = $item->request;
                    }
				}
			}	
            else
            {
                
                if($this->app->input->get('catid',0))
				{
             			$needles = array(
						'article'  => (int) $articleId, // only deal with single article Menu Item for now
						'category' => (int) $this->app->input->get('catid') // fallback to see if category has menu
					);
					
                   $menuitemid = $this->_findMenuItem($needles);
				
					$id = (int) $this->app->input->get('menuid',0);
					if(!is_null($menuitemid) && $menuitemid != $id)
					{	
						$item = $this->getItem($menuitemid);
 						$obj->request = $item->request;
                        $obj->type = 'component';
					}
				}
                else
                {
                   $menuitemid = $this->app->input->get('menuid',0);
                   if( $this->app->input->get('action','') != 'type')
                   {
                        $item = $this->getItem($menuitemid);
 				        $obj->request = $item->request;
                   }
                   $obj->type = 'component';
                }
                
            }


            $this->app->input->set('menuitemid', is_null($menuitemid) ? 0 : $menuitemid );
								
			$title = isset($type->type) ? $type->type : null;
			$specialTypes = array('alias', 'separator', 'url', 'heading');
			
			if (!in_array($title, $specialTypes))
			{
				$title = 'component';
			}
			
			
			$input = $this->app->input;
			
			$input->set('title', $title);
			$input->set('link','index.php?'.JURI::buildQuery((array) $obj->request));
 
                
			$this->type = base64_encode(json_encode($obj)); 	

            $obj->request = (array) $obj->request; 
            
         
            if(isset($obj->request['id']))
			    unset($obj->request['id']);

		
			// Load the system language file for the component.
			$lang->load($obj->request['option'].'.sys', JPATH_ADMINISTRATOR, null, false, true)
			|| $lang->load($obj->request['option'].'.sys', JPATH_ADMINISTRATOR . '/components/' . $obj->request['option'], null, false, true);
			
			// Load the language file for the component.
			$lang->load($obj->request['option'], JPATH_ADMINISTRATOR, null, false, true)
			|| $lang->load($obj->request['option'], JPATH_ADMINISTRATOR . '/components/' . $obj->request['option'], null, false, true);
					
			$this->lists['menutypes'] = JHTML::_('ark.menu.types',$this->options,'arktype', null,'value', 'text', array('request'=>$obj->request), false, true);  
            
            $menuitems = $this->_findMenuItems($needles);

           
            $this->items = $menuitems;

            $this->lists['menuitems'] = JHTML::_('select.genericlist',$menuitems,'menuitem','','id','text', $this->app->input->get('menuitem',0));

                                    
        	if($this->app->input->get('option') == 'com_arkfme' && $this->app->input->get('plugin') == 'arkfme')
			{				
				echo JLayoutHelper::render('joomla.arkfme.form.form', $this);
				exit;
			}
			else
				$this->_content = JLayoutHelper::render('joomla.arkfme.offcanvas', $this);
		}
	}
		

    public function onBeforeRender()
    {
        if($this->app->input->get('option') == 'com_content' && $this->app->input->get('view') == 'form')
		{	
            
        
            $this->_returnPage = JUri::base().'?option=com_content&task=article.edit';
            $session = JFactory::getSession();
            if($session->get('ARK.fme.return',''))
            {
               $this->_defaultReturnPage = $session->get('ARK.fme.return');
               $session->set('ARK.fme.return','');
            } 		
			else
            {
                $this->_defaultReturnPage = $this->app->input->get('return',NULL,'base64');
            }
            
            //Get Menu Item Id	
            if($this->app->input->get('a_id',0) > 0)
			{
				$this->_returnPage .='&a_id='. (int) $this->app->input->get('a_id');
			}
	
            $mid = $this->app->input->get('Itemid',$this->app->input->get('Itemid'));
			$Itemid = $mid ? '&Itemid='.$mid : '';
		    $this->_returnPage.=$Itemid;

            JFactory::getDocument()->addScriptDeclaration("
                       if(typeof ARK == 'undefined')
                            var ARK = {};
                        ARK.arkfme = {};
                        ARK.arkfme.returnPage = '".$this->getReturnPage() ."';
                ");

            JFactory::getDocument()->addScriptDeclaration("
                        ARK.arkfme.defaultReturnPage = '".$this->_defaultReturnPage ."';
                ");
            
        }
  
    }


	public function onAfterRender()
	{
        
        // Get the response body
         $body = $this->app->getBody();
		 
		if($this->_content)
				$body = preg_replace('/<\/body>/i','</body>'.$this->_content,$body);
	
		$this->app->setBody($body); 
		
		
	}
	
	
	public function getReturnPage()
	{
		if($this->_returnPage)
			return base64_encode($this->_returnPage);
		
		return $this->_returnPage;
	}
	
	
	
	public function getItem($id = null)
	{
		$id = (!empty($id)) ? $id : $this->app->input->get('menuitemid',0);
		JTable::addIncludePath(JPATH_ADMINISTRATOR . '/components/com_menus/tables');
		//include_once(JPATH_ADMINISTRATOR . '/components/com_menus/models/menu.php');
		$table = JTable::getInstance('Menu','MenusTable');
		$table->load($id);
		// Check for a table object error.
		$error = $table->getError();
			
		if ($error instanceof Exception)
		{
			throw new Exception($error);
		}
		$input = $this->app->input;
		
		$table->type = (!empty($table->type)) ?  $table->type :  $input->get('title');
		$table->link =  (!empty($table->link)) ? $table->link : $input->get('link','','RAW');
		
		if (empty($table->id))
		{
			$table->params = '{}';
		}
		
		$args = array();
		
		parse_str(parse_url($table->link, PHP_URL_QUERY), $args);
		
		// Load the language file for the menu component.
		$lang = JFactory::getLanguage();
		$lang->load('com_menus', JPATH_ADMINISTRATOR, null, false, true)
		|| $lang->load('com_menus', JPATH_ADMINISTRATOR . '/components/' . 'com_menus', null, false, true);
		
		if (isset($args['option']))
		{
			// Load the language file for the component.
			$lang->load($args['option'], JPATH_ADMINISTRATOR, null, false, true)
			|| $lang->load($args['option'], JPATH_ADMINISTRATOR . '/components/' . $args['option'], null, false, true);
			
			if ($table->type == 'component')
			{	
				// Determine the component id.
				$component = JComponentHelper::getComponent($args['option']);

				if (isset($component->id))
				{
					$table->component_id = $component->id;
				}
			}
		}
	
		$properties = $table->getProperties(1);
		$result = JArrayHelper::toObject($properties);
		
		// Convert the params field to an array.
		$registry = new JRegistry;
		$registry->loadString($table->params);
		$result->params = $registry->toArray();


        $result->request = NULL;

		// Merge the request arguments in to the params for a component.
		if ($table->type == 'component')
		{
			// Note that all request arguments become reserved parameter names.
			$result->request = $args;
			$result->params = array_merge($result->params, $args);
		}
		
		$result->menuordering = $id;
		
		return $result;
	}	
	
	
	public function getForm($data = array(), $loadData = true)
	{
		// The folder and element vars are passed when saving the form.

		// Get the form.
						
		JForm::addFormPath(JPATH_ADMINISTRATOR.'/components/com_menus/models/forms');
		JForm::addFieldPath(JPATH_ADMINISTRATOR.'/components/com_menus/models/fields');
	
		$form = JForm::getInstance('com_fme.item', 'item', array('control' => 'jform', 'load_data' => $loadData), false, false);
		
			
		$data = $this->loadFormData();
		
		if (empty($form))
		{
			return false;
		}

		if( $loadData)
			$data = $this->loadFormData();
		
		$this->preprocessForm($form, $data);	
		
		// Load the data into the form after the plugins have operated.
		$form->bind($data);

		return $form;
	}
	
	
	
	
	
	protected function loadFormData()
	{
		// Check the session for previously entered form data.
		
	    $data = array_merge((array) $this->getItem(), (array) JFactory::getApplication()->getUserState('com_fme.edit.item.data', array()));

		// For a new menu item, pre-select some filters (Status, Language, Access) in edit form if those have been selected in Menu Manager
		if ($this->getItem()->id == 0)
		{
			// Get selected fields
			$filters = JFactory::getApplication()->getUserState('com_fme.items.filter');
			$data['published'] = 1; // menus created in frontened will automatically be published
			$data['language'] = null;
			$data['access'] = null;
		}
		
		// Import the appropriate plugin group.
		JPluginHelper::importPlugin('content');

		// Get the dispatcher.
		$dispatcher = JEventDispatcher::getInstance();

		// Trigger the form preparation event.
		$results = $dispatcher->trigger('onContentPrepareData', array('com_fme.item', $data));

		// Check for errors encountered while preparing the form.
		if (count($results) && in_array(false, $results, true))
		{
			// Get the last error.
			$error = $dispatcher->getError();

			if (!($error instanceof Exception))
			{
				throw new Exception($error);
			}
		}
	

		return $data;
	}
	
	protected function preprocessForm(JForm $form, $data, $group = 'content')
	{
		$input = $this->app->input;
		$link = $input->get('link','','RAW');
		$type = $input->get('title');
		
		$formFile = false;

		// Initialise form with component view params if available.
		if ($type == 'component')
		{
			$link = htmlspecialchars_decode($link);

			// Parse the link arguments.
			$args = array();
			parse_str(parse_url(htmlspecialchars_decode($link), PHP_URL_QUERY), $args);

			// Confirm that the option is defined.
			$option = '';
			$base = '';

			if (isset($args['option']))
			{
				// The option determines the base path to work with.
				$option = $args['option'];
				$base = JPATH_SITE . '/components/' . $option;
			}

			if (isset($args['view']))
			{
				$view = $args['view'];

				// Determine the layout to search for.
				if (isset($args['layout']))
				{
					$layout = $args['layout'];
				}
				else
				{
					$layout = 'default';
				}

				// Check for the layout XML file. Use standard xml file if it exists.
				$tplFolders = array(
					$base . '/views/' . $view . '/tmpl',
					$base . '/view/' . $view . '/tmpl'
				);
				$path = JPath::find($tplFolders, $layout . '.xml');

				if (is_file($path))
				{
					$formFile = $path;
				}

				// If custom layout, get the xml file from the template folder
				// template folder is first part of file name -- template:folder
				if (!$formFile && (strpos($layout, ':') > 0))
				{
					$temp = explode(':', $layout);
					$templatePath = JPath::clean(JPATH_SITE . '/templates/' . $temp[0] . '/html/' . $option . '/' . $view . '/' . $temp[1] . '.xml');

					if (is_file($templatePath))
					{
						$formFile = $templatePath;
					}
				}
			}

			// Now check for a view manifest file
			if (!$formFile)
			{
				if (isset($view))
				{
					$metadataFolders = array(
						$base . '/view/' . $view,
						$base . '/views/' . $view
					);
					$metaPath = JPath::find($metadataFolders, 'metadata.xml');

					if (is_file($path = JPath::clean($metaPath)))
					{
						$formFile = $path;
					}
				}
				else
				{
					// Now check for a component manifest file
					$path = JPath::clean($base . '/metadata.xml');

					if (is_file($path))
					{
						$formFile = $path;
					}
				}
			}
		}

		if ($formFile)
		{
			// If an XML file was found in the component, load it first.
			// We need to qualify the full path to avoid collisions with component file names.

			if ($form->loadFile($formFile, true, '/metadata') == false)
			{
				throw new Exception(JText::_('JERROR_LOADFILE_FAILED'));
			}

			// Attempt to load the xml file.
			if (!$xml = simplexml_load_file($formFile))
			{
				throw new Exception(JText::_('JERROR_LOADFILE_FAILED'));
			}

			// Get the help data from the XML file if present.
			$help = $xml->xpath('/metadata/layout/help');
		}
		else
		{
			// We don't have a component. Load the form XML to get the help path
			$xmlFile = JPath::find(JPATH_ROOT . '/administrator/components/com_menus/models/forms', 'item_' . $type . '.xml');

			// Attempt to load the xml file.
			if ($xmlFile && !$xml = simplexml_load_file($xmlFile))
			{
				throw new Exception(JText::_('JERROR_LOADFILE_FAILED'));
			}

			// Get the help data from the XML file if present.
			$help = $xml->xpath('/form/help');
		}

		if (!empty($help))
		{
			$helpKey = trim((string) $help[0]['key']);
			$helpURL = trim((string) $help[0]['url']);
			$helpLoc = trim((string) $help[0]['local']);

			$this->helpKey = $helpKey ? $helpKey : $this->helpKey;
			$this->helpURL = $helpURL ? $helpURL : $this->helpURL;
			$this->helpLocal = (($helpLoc == 'true') || ($helpLoc == '1') || ($helpLoc == 'local')) ? true : false;
		}

		// Load the specific type file
		if (!$form->loadFile('item_' . $type, false, false))
		{
			throw new Exception(JText::_('JERROR_LOADFILE_FAILED'));
		}

		// Association menu items
		$app = JFactory::getApplication();
		$assoc = JLanguageAssociations::isEnabled();

		if ($assoc)
		{
			$languages = JLanguageHelper::getLanguages('lang_code');

			$addform = new SimpleXMLElement('<form />');
			$fields = $addform->addChild('fields');
			$fields->addAttribute('name', 'associations');
			$fieldset = $fields->addChild('fieldset');
			$fieldset->addAttribute('name', 'item_associations');
			$fieldset->addAttribute('description', 'COM_MENUS_ITEM_ASSOCIATIONS_FIELDSET_DESC');
			$add = false;

			foreach ($languages as $tag => $language)
			{
				if ($tag != $data['language'])
				{
					$add = true;
					$field = $fieldset->addChild('field');
					$field->addAttribute('name', $tag);
					$field->addAttribute('type', 'menuitem');
					$field->addAttribute('language', $tag);
					$field->addAttribute('label', $language->title);
					$field->addAttribute('translate_label', 'false');
					$option = $field->addChild('option', 'COM_MENUS_ITEM_FIELD_ASSOCIATION_NO_VALUE');
					$option->addAttribute('value', '');
				}
			}

			if ($add)
			{
				$form->load($addform, false);
			}
		}

		// Trigger the default form events.
		$this->_preprocessForm($form, $data, $group);
	}
	
	private function _preprocessForm(JForm $form, $data)
	{

		// Get the dispatcher.
		$dispatcher = JEventDispatcher::getInstance();

		// Trigger the form preparation event.
		$results = $dispatcher->trigger('onContentPrepareForm', array($form, $data));

		// Check for errors encountered while preparing the form.
		if (count($results) && in_array(false, $results, true))
		{
			// Get the last error.
			$error = $dispatcher->getError();

			if (!($error instanceof Exception))
			{
				throw new Exception($error);
			}
		}
	}
	
	private function _findMenuItem($needles = null)
	{
		$menus   = $this->app->getMenu('site');	
				
		$component  = JComponentHelper::getComponent('com_content');

		$attributes = array('component_id');
		$values     = array($component->id);
		
		$items = $menus->getItems($attributes, $values);


        $lookup = array();

		foreach ($items as $item)
		{
			if (isset($item->query) && isset($item->query['view']))
			{
				$view = $item->query['view'];
	
				if (!isset($lookup[$view]))
				{
					$lookup[$view] = array();
				}
				
				if (isset($item->query['id']))
				{
					$lookup[$view][$item->query['id']] = $item->id;
				}
			}	
		}
		
		if ($needles)
		{
			foreach ($needles as $view => $id)
			{
				if (isset($lookup[$view]))
				{
					if (isset($lookup[$view][(int) $id]))
						return $lookup[$view][(int) $id];
				}
			}
		}
		
		return null;
	}	
	

    	
	private function _findMenuItems($needles = null)
	{
		$menus   = $this->app->getMenu('site');	

        $results = array();
				
		$component  = JComponentHelper::getComponent('com_content');

		$attributes = array('component_id');
		$values     = array($component->id);
		
		$items = $menus->getItems($attributes, $values);

        $lookup = array();

        $menuitems = array();

		foreach ($items as $raw)
		{
			if (isset($raw->query) && isset($raw->query['view']))
			{
				$view = $raw->query['view'];
	
				if (!isset($this->_lookup[$view]))
				{
					$lookup[$view] = array();
				}
             
				if (isset($raw->query['id']))
				{
                    $obj = new stdclass;
                    $obj->id = $raw->id;
                    $obj->qid = $raw->query['id'];
                    $obj->text = $raw->alias;
                    $obj->view = $view;
                    $menuitems[] = $obj;
				}
                
			}	
		}

        foreach($lookup as $view =>$arry)
        {
            foreach($menuitems as $item)
            {
               if($item->view == $view)
                $arry[] = $item;  
            }
            $lookup[$view] = $arry;
        }

  		if ($needles)
		{
			foreach ($needles as $view => $id)
			{
		             
                for($i = 0; $i <  count($lookup[$view]) ; $i++ )
                {
                    if (isset($lookup[$view][$i]) && is_object($lookup[$view][$i])){
                        if($lookup[$view][$i]->qid == $id  )
						    $results[] = $lookup[$view][$i];
                    }

				}
			}
		}
	    return array_reverse($results);
	}	
	



	
	private function getTypeOptionsFromLayouts($component, $view)
	{
		$options     = array();
		$layouts     = array();
		$layoutNames = array();
		$lang        = JFactory::getLanguage();
		$path        = '';

		// Get the views for this component.
		if (is_dir(JPATH_SITE . '/components/' . $component))
		{
			$folders = JFolder::folders(JPATH_SITE . '/components/' . $component, '^view[s]?$', false, true);
		}

		if (!empty($folders[0]))
		{
			$path = $folders[0] . '/' . $view . '/tmpl';
		}

		if (is_dir($path))
		{
			$layouts = array_merge($layouts, JFolder::files($path, '.xml$', false, true));
		}
		else
		{
			return $options;
		}

		// Build list of standard layout names
		foreach ($layouts as $layout)
		{
			// Ignore private layouts.
			if (strpos(basename($layout), '_') === false)
			{
				// Get the layout name.
				$layoutNames[] = basename($layout, '.xml');
			}
		}

		// Get the template layouts
		// TODO: This should only search one template -- the current template for this item (default of specified)
		$folders = JFolder::folders(JPATH_SITE . '/templates', '', false, true);

		// Array to hold association between template file names and templates
		$templateName = array();

		foreach ($folders as $folder)
		{
			if (is_dir($folder . '/html/' . $component . '/' . $view))
			{
				$template = basename($folder);
				$lang->load('tpl_' . $template . '.sys', JPATH_SITE, null, false, true)
				|| $lang->load('tpl_' . $template . '.sys', JPATH_SITE . '/templates/' . $template, null, false, true);

				$templateLayouts = JFolder::files($folder . '/html/' . $component . '/' . $view, '.xml$', false, true);

				foreach ($templateLayouts as $layout)
				{
					// Get the layout name.
					$templateLayoutName = basename($layout, '.xml');

					// Add to the list only if it is not a standard layout
					if (array_search($templateLayoutName, $layoutNames) === false)
					{
						$layouts[] = $layout;

						// Set template name array so we can get the right template for the layout
						$templateName[$layout] = basename($folder);
					}
				}
			}
		}

		// Process the found layouts.
		foreach ($layouts as $layout)
		{
			// Ignore private layouts.
			if (strpos(basename($layout), '_') === false)
			{
				$file = $layout;

				// Get the layout name.
				$layout = basename($layout, '.xml');

				// Create the menu option for the layout.
				$o = new JObject;
				$o->title       = ucfirst($layout);
				$o->description = '';
				$o->request     = array('option' => $component, 'view' => $view);

				// Only add the layout request argument if not the default layout.
				if ($layout != 'default')
				{
					// If the template is set, add in format template:layout so we save the template name
					$o->request['layout'] = (isset($templateName[$file])) ? $templateName[$file] . ':' . $layout : $layout;
				}

				// Load layout metadata if it exists.
				if (is_file($file))
				{
					// Attempt to load the xml file.
					if ($xml = simplexml_load_file($file))
					{
						// Look for the first view node off of the root node.
						if ($menu = $xml->xpath('layout[1]'))
						{
							$menu = $menu[0];

							// If the view is hidden from the menu, discard it and move on to the next view.
							if (!empty($menu['hidden']) && $menu['hidden'] == 'true')
							{
								unset($xml);
								unset($o);
								continue;
							}

							// Populate the title and description if they exist.
							if (!empty($menu['title']))
							{
								$o->title = trim((string) $menu['title']);
							}

							if (!empty($menu->message[0]))
							{
								$o->description = trim((string) $menu->message[0]);
							}
						}
					}
				}

				// Add the layout to the options array.
				$options[] = $o;
			}
		}

		return $options;
	}
		
}