<?php
/*------------------------------------------------------------------------
# Copyright (C) 2016-2017 WebxSolution Ltd. All Rights Reserved.
# @license - GPLv2.0
# Author: WebxSolution Ltd
# Websites:  http://www.webxsolution.com
# Terms of Use: An extension that is derived from the JoomlaCK editor will only be allowed under the following conditions: http://joomlackeditor.com/terms-of-use
# ------------------------------------------------------------------------*/ 

defined('_JEXEC') or die;

/**
 *Ark Typography Ajax Plugin
 *
 * @package     Joomla.Plugin
 * @subpackage  Ajax.arkfme
 */

error_reporting(E_ERROR & ~E_NOTICE);
 
class PlgContentArkFME extends JPlugin
{

	public $db, $app;
	
	private $contexts = array('com_content.form');
	
    public function onContentAfterSave($context,$article,$isNew  )
	{
		
		$data = $this->app->getUserState('com_fme.edit.item.data');

		if(!in_array($context,$this->contexts))
			return false;
		
	    $input = $this->app->input;

		
		if($isNew)
		{	
			$return = $input->get('return', null, 'base64');	
			if(!empty($return))
			{
				$return = base64_decode($return);
				$return .= '&a_id='.$article->id;
     		    $input->set('return',base64_encode($return));
			}	
        }
        else
        {
            $return = $input->get('arkreturn', null, 'base64');	
			if(!empty($return))
			{
                $session = JFactory::getSession();
                $session->set('ARK.fme.return',$return);
            }
        }
        
        if(empty($data))
			return false;
				
		$lang = JFactory::getLanguage();
		$lang->load('com_menus', JPATH_ADMINISTRATOR, null, false, true)
		|| $lang->load('com_menus', JPATH_ADMINISTRATOR . '/components/' . 'com_menus', null, false, true);
		
		JModelLegacy::addIncludePath(JPATH_PLUGINS.'/ajax/arkfme/models');
		
		$model  = JModelLegacy::getInstance('Item', 'MenusModel'); 
			
		$id =  $article->id;
		
		$args = array();
		parse_str(parse_url($data['link'], PHP_URL_QUERY), $args);
		if(isset($args['view']) && $args['view'] == 'category')
		{
			$catid = $article->catid;
			$data['link'] .= '&id='.$catid;
		}	
		else
			$data['link'] .= '&id='.$id;
		
		
		
		if ($model->save($data))
		{	
			$this->app->setUserState( 'com_fme.edit.item.data', null );
			$this->app->enqueueMessage(JText::_('COM_MENUS_SAVE_SUCCESS'));	
		}
		else
		{
			$message = $model->getError();
			$this->app->enqueueMessage(JText::sprintf('JLIB_APPLICATION_ERROR_SAVE_FAILED', $message), 'warning');
		}

		// Save succeeded, check-in the row.
		$model->checkin($data['id']);
		
	}	
}