<?php

defined( '_JEXEC' ) or die;

class plgButtonArkFME extends JPlugin
{
	/**
	 * @var		string	Default Ark Icon CSS Name
	 */
	protected $icon 	= 'arkmenu';

	/**
	 * @var		string	Default Ark Colour
	 */
	protected $colour 	= 'primary';

	/**
	 * @var		bool	Load the Language File on Instantiation.
	 */
	protected $autoloadLanguage = true;

	/**
	 * Display An Ark Extension Button.
	 *
	 * @param	string	$name	The Name of the Button to Display.
	 * @param	string	$asset	The Name of the Asset Being Edited.
	 * @param	int		$author	The ID of the Author Owning the Asset Being Edited.
	 *
	 * @return	array	A Two Element Array of (imageName, textToInsert) or false if not Authorised.
	 */
	public function onDisplay( $name, $asset, $author )
	{
		$app		= JFactory::getApplication();
		$doc		= JFactory::getDocument();
		$user 		= JFactory::getUser();
		$extension 	= $app->input->get( 'option' );

		// Bail out for ajax calls to prevent harming our wonderful Ark Menu Extension
		if( $extension === 'com_ajax' )
		{
			return;
		}//end if

		// FE only
		if( $app->isAdmin() )
		{
			return;
		}//end if

		if( !$asset )
		{
			$asset = $extension;
		}//end if

		if( 
			($user->authorise('core.create', 'com_menus.menu') || $user->authorise('core.edit', 'com_menus.menu')) 		
			&& ($user->authorise( 'core.edit', $asset )
			|| $user->authorise( 'core.create', $asset )
			|| ( count( $user->getAuthorisedCategories( $asset, 'core.create' ) ) > 0 )
			|| ($user->authorise( 'core.edit.own', $asset ) && $author == $user->id )
			|| ( count( $user->getAuthorisedCategories( $extension, 'core.edit') ) > 0 )
			|| ( count( $user->getAuthorisedCategories( $extension, 'core.edit.own') ) > 0 && $author == $user->id ))
		)
		{
            // Load Logo Font
			$doc->addStyleSheet( JURI::base() . 'plugins/editors-xtd/arkfme/assets/css/ark-logo.min.css' );

			$colour				= $this->params->get( 'colour', $this->colour );
			$button 			= new JObject;
			$button->modal 		= false;
			$button->id			= $name;
			$button->class		= 'btn btn-' . $colour;
			$button->link 		= '#'; // Can't javascript:void Till Joomla Stops JRouting the Link
			$button->onclick 	= "this.href = '#'; ARKUK.offcanvas.show( '#ark-fme-offcanvas' ); return false;"; // Return False to Cancel Page Submission
			$button->text 		= $this->params->get( 'text', JText::_( 'PLG_EDITORS-XTD_ARKFME_BTN' ) );
			$button->name 		= $this->params->get( 'icon', $this->icon );

			return $button;
		}//end if

		return false;
	}//end function
}//end class