<?php
/*------------------------------------------------------------------------
# Copyright (C) 2015-2016 WebxSolution Ltd. All Rights Reserved.
# @license - GPLv2.0
# Author: WebxSolution Ltd
# Websites:  http://www.webxsolution.com
# Terms of Use: An extension that is derived from the JoomlaCK editor will only be allowed under the following conditions: http://joomlackeditor.com/terms-of-use
# ------------------------------------------------------------------------*/ 

defined('_JEXEC') or die;

/**
 *Ark Typography Ajax Plugin
 *
 * @package     Joomla.Plugin
 * @subpackage  Ajax.arkbootstrap
 */

error_reporting(E_ERROR & ~E_NOTICE);
 
class PlgAjaxArkFme extends JPlugin
{

	public $db, $app;
	
    public function onAjaxArkFME()
	{
		$input = $this->app->input;
				
		$task = $input->get('task','store');
		$id =  $input->get('a_id',0); 
		
		if(!$id)
			return $this->store(true);
		else
			return $this->save();
	}	
			
	protected function store($isNew = false) 
	{
		
		$results = NULL;
        
        
        $this->app = JFactory::getApplication();
		$input = $this->app->input;
		
		JModelLegacy::addIncludePath(JPATH_PLUGINS.'/ajax/arkfme/models');		
		$model    = JModelLegacy::getInstance('Item', 'MenusModel'); 
		$data     = $input->post->get('jform', array(), 'array');
		
		
		$context  = 'com_menus.edit.item';
		
		// Validate the posted data.
		// This post is made up of two forms, one for the item and one for params.
		$form = $model->getForm($data);
		
		$isErr = false;
		
        try
        {
	
			$user = JFactory::getUser();
			
			if(!$user->id)
				throw new Exception('Session has expired. Please log in.');		

			$menuTypeID = 0;
			$menuType = $data['menutype'];
			
			if ($menuType)
			{
				$menutypeID = (int) $this->getMenuTypeId($menuType);
			}

			//Are we allowed to create or edit menu items
			if($isNew)
			{
				if(!$user->authorise('core.create', 'com_menus.menu.' . $menutypeID))
					throw new Exception(JText::_('JLIB_APPLICATION_ERROR_SAVE_NOT_PERMITTED'));
			}
			else
			{
				if(!$user->authorise('core.edit', 'com_menus.menu.' . $menutypeID))
					throw new Exception(JText::_('JLIB_APPLICATION_ERROR_SAVE_NOT_PERMITTED'));	
			}	
			
		
		    if (!$form)
		    {
			    $message = $model->getError();
			    throw new Exception($message);
		    }
		
				
		    $type = $input->get('type'); 
		
		    $type = json_decode(base64_decode($type));

		    if(!isset($data['type']))
		    {
			    $message = 'Menu type not supplied! Please contact your Web Master if this problem persists.';
			    throw new Exception($message);
		    }

			
		    if ($data['type'] == 'url')
		    {
			    $data['link'] = str_replace(array('"', '>', '<'), '', $data['link']);

			    if (strstr($data['link'], ':'))
			    {
				    $segments = explode(':', $data['link']);
				    $protocol = strtolower($segments[0]);
				    $scheme = array('http', 'https', 'ftp', 'ftps', 'gopher', 'mailto', 'news', 'prospero', 'telnet', 'rlogin', 'tn3270', 'wais', 'url',
					    'mid', 'cid', 'nntp', 'tel', 'urn', 'ldap', 'file', 'fax', 'modem', 'git');

				    if (!in_array($protocol, $scheme))
				    {
					    $this->app->enqueueMessage(JText::_('JLIB_APPLICATION_ERROR_SAVE_NOT_PERMITTED'), 'warning');
					    $message = JText::_('JLIB_APPLICATION_ERROR_SAVE_NOT_PERMITTED');
					    throw new Exception($message);
				    }
			    }
		    }

		
		    if($isNew)
			    $data['request']['id'] = -1;
		    else
            {
			    $menuid = $input->post->get('menuid',0);
                if($menuid)
                    $data['id'] = $input->post->get('menuid');
                else
                   $data['request']['id'] =  $input->get('a_id',0); 
    
		    }	
		
		    $data = $model->validate($form, $data);
				
		    // Check for validation errors.
		    if ($data === false)
		    {
			    // Get the validation messages.
			    $errors = $model->getErrors();
			    $messages = array();

			    // Push up to three validation messages out to the user.
			    for ($i = 0, $n = count($errors); $i < $n && $i < 3; $i++)
			    {
				    if ($errors[$i] instanceof Exception)
				    {
					    $this->app->enqueueMessage($errors[$i]->getMessage(), 'warning');
					    $messages[] = $errors[$i]->getMessage();
				    }
				    else
				    {
					    $this->app->enqueueMessage($errors[$i], 'warning');
					    $messages[] = $errors[$i];
				    }
			    }
				
			    // Save the data in the session.
			    $this->app->setUserState('com_fme.edit.item.data', $data);
			    $msg = implode('<br>',$messages);
			    throw new Exception($msg);
			}
			
				
		    // Check for the special 'request' entry.
		    if ($data['type'] == 'component' && isset($data['request']) && is_array($data['request']) && !empty($data['request']))
		    {
			    $removeArgs = array();

			    // Preprocess request fields to ensure that we remove not set or empty request params
			    $request = $form->getGroup('request');

			    if (!empty($request))
			    {
				    foreach ($request as $field)
				    {
					    $fieldName = $field->getAttribute('name');
					
					    if (!isset($data['request'][$fieldName]) || $data['request'][$fieldName] == '')
					    {
						    $removeArgs[$fieldName] = '';
					    }
				    }
			    }

			    // Parse the submitted link arguments.
			    $args = array();
			    parse_str(parse_url($data['link'], PHP_URL_QUERY), $args);



			    // Merge in the user supplied request arguments.
			    $args = array_merge($args, $data['request']);

			    // Remove the unused request params
			    if (!empty($args) && !empty($removeArgs))
			    {
				    $args = array_diff_key($args, $removeArgs);
			    }



            
                if( isset($args['id']) && $args['id'] > 0)
                {
                    if(isset($args['view']) && $args['view'] == 'category')
		            {
			           $table = JTable::getInstance('content');
                       $table->load($args['id']);
                       $catid = $table->catid;
			            $args['id'] = $catid;
		            }
                }   	
		        else
                {
			        if(isset($args['id']))
                        unset($args['id']);
                }
            
                 if(isset($args['a_id']))
                        unset($args['a_id']);

			    $data['link'] = 'index.php?' . urldecode(http_build_query($args, '', '&'));
			    unset($data['request']);
		    }

		    $this->app->setUserState( 'com_fme.edit.item.data', $data );
		
		
		    $message  = "Menu details stored successufully. Menu will be created when new article is saved.";
		
            $results = array('message'=>$message);

        }
        catch (Exception $e)
	    {
		        $results = $e;
				$isErr = true;
	    }
            
	    if($isNew || $isErr)
        {
            header('Content-Type: application/json');
            echo new JResponseJson($results, null, false, $input->get('ignoreMessages', true, 'bool'));
            exit;
        }

	}

	protected function save()
	{
		$this->store();
	
		$data = $this->app->getUserState('com_fme.edit.item.data');
		
		JModelLegacy::addIncludePath(JPATH_PLUGINS.'/ajax/arkfme/models');
		
		$model = JModelLegacy::getInstance('Item', 'MenusModel'); 
		
		$lang = JFactory::getLanguage();
		$lang->load('com_menus', JPATH_ADMINISTRATOR, null, false, true)
		|| $lang->load('com_menus', JPATH_ADMINISTRATOR . '/components/' . 'com_menus', null, false, true);
		
		try
        {
		    if ($model->save($data))
		    {	
			    $this->app->setUserState( 'com_fme.edit.item.data', null );
			    $message = JText::_('COM_MENUS_SAVE_SUCCESS');
			    $this->app->enqueueMessage($message);	
                // Save succeeded, check-in the row.
                if(isset($data['id']) && !empty($data['id']))
	    	        $model->checkin($data['id']);
			    $results =  array('message'=>$message,'id'=>$model->getState('item.id'));
		    }
		    else
		    {
			    $message = $model->getError();
			    $this->app->enqueueMessage(JText::sprintf('JLIB_APPLICATION_ERROR_SAVE_FAILED', $message), 'warning');
			    throw new Exception($message);
		    }
        }
         catch (Exception $e)
	    {
		        $results = $e;
                exit;
	    }

        header('Content-Type: application/json');
        echo new JResponseJson($results, null, false,  $this->app->input->get('ignoreMessages', true, 'bool'));
		exit;
	}	
	
	
	protected function getMenuTypeId($menutype)
	{
		$table = JTable::getInstance('MenuType', 'JTable'); 
		$table->load(array('menutype' => $menutype));
		
		return (int) $table->id;
	}
	
}