(function( $ )
{
	$.fn.ark 		= $.fn.ark || {};
	$.fn.ark.canvas = $.fn.ark.canvas || {};

	// Already loaded?
	if( $.fn.ark.canvas.hasOwnProperty( 'once' ) )
	{
		return;
	}//end if

	// One time initialisation logic
	$.fn.ark.canvas.once = function()
	{
		// Recalculate scrollbar on accordion change
		$( document ).on( 'click', '#ark-fme-offcanvas .ark-accordion-title-link', function()
		{
			var animation = 300;

			// Wait till accordion animation has finished (plus a bit)
			$( this ).delay( animation + 10 ).queue( function( fn )
			{
				$( '.nano' ).nanoScroller(
				{
					iOSNativeScrolling	: true,
					alwaysVisible		: true
				});

				fn();
			});
		});

		// Plumb in to-top scroller
		$( document ).on( 'click', '[data-ark-smooth-scroll]', function()
		{
			$.fn.ark.canvas.scroll();
		});

		// Plumb in save dropdown list
		// @note	Use timeouts to prevent re-activation of class when hovering off (looks like a skip in the animation)
		// @see		http://stackoverflow.com/questions/1273566/how-do-i-check-if-the-mouse-is-over-an-element-in-jquery/1670561#1670561
		$( document ).on( 'mouseenter', '#ark-fme-save', function()
		{
			clearTimeout( $( this ).data( 'timeoutid' ) );

			$( this ).find( '.ark-fme-save-list' ).addClass( 'in' );
		})
		.on( 'mouseleave', '#ark-fme-save', function()
		{
			var $el = $( this ).find( '.ark-fme-save-list' );

			timeoutid = setTimeout( function()
			{
				$el.removeClass( 'in' );
			}, 100 );

			$( this ).data( 'timeoutid', timeoutid );
		});

		// Plumb in new
		$( document ).on( 'click', '[data-ark-new]', function( ev )
		{
			var $id = $( '.ark-fme-field-id' );
			var $el = $( '#ark-fme-offcanvas' );

			// Clear hidden/visible values
			$id.find( 'input' ).val( '' );
			$id.find( '.ark-fme-field-value' ).html( '0' );
			$el.find( '#jform_alias' ).val( '' );
			$el.find( '#menuid' ).val( '' );
			$el.find('#jform_title').val( '' );
			$el.find('#menutitle').val( '' );
			$el.find('#ark-fme-btn-save').toggleClass('ark-hidden');
			$el.find('#ark-fme-save').toggleClass('ark-hidden');
			
			// Switch Badge
			$id.find( '.ark-badge' ).removeClass( 'ark-hidden' );

			return false;
		});

		// Plumb in save as copy (not currently in use)
		$( document ).on( 'click', '[data-ark-save-copy]', function( ev )
		{
			var $id = $( '.ark-fme-field-id' );
			var $el = $( '#ark-fme-offcanvas' );

			// Clear hidden/visible values
			$id.find( 'input' ).val( '' );
			$id.find( '.ark-fme-field-value' ).html( '0' );
			$el.find( '#jform_alias' ).val( '' );
			$el.find( '#menuid' ).val( '' );
			
			//Add copy to end of title
			$title  = $el.find('#jform_title');
			$title2 = $el.find('#menutitle');
			if($title.val() == $title2.val())
			  $title.val($title2.val()+'-copy');				

			// Switch Badge
			$id.find( '.ark-badge' ).removeClass( 'ark-hidden' );
		});

		// Close dropdown on button click
		$( document ).on( 'click', '.ark-fme-save-list .ark-button', function( ev )
		{
			$( '#ark-fme-save' ).trigger( 'mouseleave' );
		});
	}//end function

	// Multiple initialisation logic
	$.fn.ark.canvas.every = function()
	{
		// Initialise accordion togglers
		$( '#ark-fme-offcanvas' ).find( '.ark-accordion-title-link' ).each( function( i, el )
		{
			ARKUK.toggleCaret( el, {
				target			:'.toggle', 
				clsOff 			: 'ark-icon-caret-down', 
				clsOn 			: 'ark-icon-caret-up', 
				defaultClsOn	: !i
			});
		});

		// Initialise JS scrollbar (delay to allow canvas to open)
		$( '#ark-fme-offcanvas .nano' ).delay( 100 ).queue( function( fn )
		{
			$( '.nano' ).nanoScroller(
			{
				iOSNativeScrolling	: true,
				alwaysVisible		: true
			});

			fn();
		});

		// Throttle/debounce scroll tracking for better performance
		var scroll = ARKUK.Utils.debounce( function()
		{
			var css = 'ark-fme-toolbar-on';
			var $toolbar = $( this ).parent( '.nano' ).find( '.ark-fme-toolbar' );

			if( $( this ).scrollTop() <= 2 )
			{
				if( $toolbar.hasClass( css ) )
				{
					$toolbar.removeClass( css );

					// Hide to-top scroller
					$('[data-ark-smooth-scroll]').fadeOut();
				}//end if
			}
			else
			{
				if( !$toolbar.hasClass( css ) )
				{
					$toolbar.addClass( css );

					// Reveal to-top scroller
					$('[data-ark-smooth-scroll]').fadeIn();
				}//end if
			}//end if
		}, 100 );

		// Initialise scroll tracking
		$( '#ark-fme-offcanvas .nano-content' ).scroll( scroll );

		// Hide to-top scroller initially
		$('[data-ark-smooth-scroll]').fadeOut();

		// Add list default check updater on click
		if( $.fn.chosen )
		{
			// Calculate default options for extra scrolling (if: "- SOMETHING -")
			$( '#ark-fme-offcanvas' ).find( '.chzn-done' ).chosen().change(function()
			{
				$.fn.ark.canvas.listdefault( this );
			});
		}//end if

		// Onload of page/form grab the parsed lists & check the values
		$( '#ark-fme-offcanvas' ).find( '.chzn-done' ).each(function( i, el )
		{
			$.fn.ark.canvas.listdefault( this );
		});
	}//end function

	// External functions
	$.fn.ark.canvas.listdefault = function( list )
	{
		var $opt	= $( list ).find( ':selected' );
		var val 	= $opt.val();
		var text 	= $opt.text();
		var langs	= [Joomla.JText._( 'JGLOBAL_USE_GLOBAL' ), Joomla.JText._( 'PLG_SYSTEM_ARKFME_GLOBAL_OPT' )];
		var $select	= $( '#' + $( list ).attr( 'id' ) + '_chzn' ); // Find chosen partner

		// If a default option beginning & ending with '-': '- ENTRY -' set to default
		if( text.charAt( 0 ) === '-' && text.slice( -1 ) === '-' && ( !val || val === '0' ) )
		{
			$select.addClass( 'chzn-option-default' );
		}
		// If a "Global" option, set to default
		else if( $.inArray( text, langs ) !== -1 && ( !val || val === '0' ) )
		{
			$select.addClass( 'chzn-option-default' );
		}
		// A normal option
		else
		{
			$select.removeClass( 'chzn-option-default' );
		}//end if
	}//end function

	// External functions
	$.fn.ark.canvas.scroll = function( offset, speed )
	{
		offset 	= offset || 0;
		speed	= speed || 700;

		// Scroll to top
		$('.nano-content').stop().animate({ scrollTop : offset }, speed );

		// @note Nano Version (doesn't animate)
		// $( '.nano' ).nanoScroller({ scroll : 'top' });

		// @note UIkit Version (only works on body scrolling): [data-ark-smooth-scroll]
		// ARKUK.Utils.scrollToElement
	}//end function
})(jQuery);