
(function(UI){

    "use strict";

    var toggles = [];

    UI.component('toggleCaret', {

        defaults: {
            target    : false,
            clsOff    : 'ark-icon-caret-right',
			clsOn     : 'ark-icon-caret-down',
			defaultClsOn : false
        },

        boot: function(){

            // init code
            UI.ready(function(context) {

                UI.$("[data-ark-togglecaret]", context).each(function() {
                    var ele = UI.$(this);
					
                    if (!ele.data("togglecaret")) {
                        var obj = UI.toggleCaret(ele, UI.Utils.options(ele.attr("data-ark-togglecaret")));
                    }
					ele.css('width','100%'); //set width
                });

                setTimeout(function(){

                    toggles.forEach(function(toggle){
                        toggle.getToggles();
	
						if(toggle.options.defaultClsOn)
							toggle.element.find('i').removeClass(toggle.options.clsOff).addClass(toggle.options.clsOn);
						
	                  });

                }, 0);
            });
        },

        init: function() {

            var $this = this;

            this.getToggles();
			
			this.element.find('i').addClass(this.options.clsOff);

            this.on("click", function(e) {
				
                if ($this.element.is('a[href="#"]')) 
					e.preventDefault();
				
			    $this.reset();
				var elem = $this.element.find('i');
				if(!elem.hasClass($this.options.clsOn)) 
					elem.removeClass($this.options.clsOff);
				$this.element.find('i').toggleClass($this.options.clsOn);
			});

            toggles.push(this);
        },

        reset: function() {

            if(!this.totoggle.length) return;
			
			this.totoggle.addClass(this.options.clsOff);
        },

        getToggles: function() {
            this.totoggle = this.options.target ? UI.$(this.options.target):[];
        }
    });

})(UIkit);