<?php 

defined('JPATH_PLATFORM') or die;


abstract class ARKMenu
{
	
	public static function types($data,$name,$attribs = null , $optKey = 'value', $optText = 'text',	$selected = null, $idtag = false, $translate = false)
	{	
		
		
		// Set default options
		$options = array_merge(JHtml::$formatOptions, array('format.depth' => 0, 'id' => false));
		
		// Get options from the parameters
		if (is_array($attribs) && func_num_args() == 3)
		{
			// Assume we have an options array
			$options = array_merge($options, $attribs);
		}
		else
		{	
			$options['id'] = $idtag;
			$options['list.attr'] = $attribs;
			$options['list.translate'] = $translate;
			$options['option.key'] = $optKey;
			$options['option.text'] = $optText;
		}
		
		$attribs = '';

		if(isset($options['list.attr']))
		{
			if (is_array($options['list.attr']))
			{
				$attribs = JArrayHelper::toString($options['list.attr']);
			}
			else
			{
				$attribs = $options['list.attr'];
			}

			if ($attribs != '')
			{
				$attribs = ' ' . $attribs;
			}
		}
	
		$id = $options['id'] !== false ? $options['id'] : $name;
		$id = str_replace(array('[', ']'), '', $id);
	
	
		$types = array();
		$parts = (array) $selected;

		foreach($data as $item)
		{
			$type = new stdclass;
			$type->$optText = $item->title;
			
			$type->$optKey = base64_encode(json_encode($item->request));
			$types[] = $type; 
			
			if(!empty($selected) && isset($parts['request']))
			{
				if(JURI::buildQuery((array) $item->request) == JURI::buildQuery((array) $parts['request']))
					$selected = $type->$optKey;
			}
		}
	
		$options['list.select'] = $selected;
				
		$baseIndent = str_repeat($options['format.indent'], $options['format.depth']++);	
		return  $baseIndent . '<select' . ($id !== '' ? ' id="' . $id . '"' : '') . ' name="' . $name . '"' . $attribs . '>' . $options['format.eol']
		. JHTML::_('select.options',$types, $options) . $baseIndent . '</select>' . $options['format.eol'];	
			
	}
}