<?php

defined( '_JEXEC' ) or die;

// Get field
$form 	= $displayData['form'];
$field 	= $displayData['field'];

// Valid field
if( !$field )
{
	return;
}
else
{
	$html 	= '';
	$old	= array();
	$new	= array();
	$type	= 'none';

	// Plain String or JForm Field?
	// @note get_parent_class() doesn't always return JFormField
	if( is_string( $field ) )
	{
		$html = $field;
	}
	elseif( is_object( $field ) )
	{
		$html = $field->input;
		$type = strtolower( $field->type );

		// Extra field specific logic
		switch( $type )
		{
			case 'media' :
				// Change preview icon
				$old[]	=  'icon-eye';
				$new[]	=  'ark-icon-justify ark-icon-eye';
				// Change "Select" to icon
				$old[]	=  JText::_( 'JLIB_FORM_BUTTON_SELECT' ) . '</a>';
				$new[]	=  '<i class="ark-icon-justify ark-icon-mouse-pointer"></i>';
				// Change remove icon
				$old[]	=  'icon-remove';
				$new[]	=  'ark-icon-justify ark-icon-times';
				break;

			case 'menuordering' :
				// Style Menu Order Label
				$old[]	=  'class="readonly"';
				$new[]	=  'class="readonly ark-alert ark-text-break"';
				// Add Close Button
				$old[]	= JText::_( 'COM_MENUS_ITEM_FIELD_ORDERING_TEXT' );
				$new[]	= JText::_( 'COM_MENUS_ITEM_FIELD_ORDERING_TEXT' ) . '<a href="javascript:void(0);" class="ark-alert-close ark-close"></a>';
				// Add Close Button JS Logic
				$old[]	= 'class="readonly';
				$new[]	= 'data-ark-alert class="readonly';
				break;

			case 'radio' :
				// Get field
				$xml		= $form->getXML();
				$element 	= current( $xml->xpath( '//field[@name="' . $field->fieldname . '"]' ) );
				$count		= count( $element->option );

				// Too many options for our skinny view?
				if( $count > 3 )
				{
					// Convert to a list
					$element['type'] 	= 'list';
					$element['class'] 	= '';
					$field = $form->getField( $field->fieldname, $field->group );

					// Re-render the field (rather than echo in case extra switch logic is required)
					echo JLayoutHelper::render( 'joomla.arkfme.form.field', array( 'field' => $field, 'xml' => $xml, 'form' => $form ) );

					return;
				}//end if
				break;
		}//end switch
	}//end if

	// Simplify "Use Global" labels
	$old[]	=  JText::_( 'JGLOBAL_USE_GLOBAL' );
	$new[]	=  JText::_( 'PLG_SYSTEM_ARKFME_GLOBAL_OPT' );

	// Customise HTML
	$html 	= str_replace( $old, $new, $html );

	// Render field
	echo '<div class="ark-form-controls ark-fme-field-' . $type . '">' . $html . '</div>';
}//end if