<?php
/**
 * @package     Joomla.Site
 * @subpackage  Layout
 *
 * @copyright   Copyright (C) 2005 - 2015 Open Source Matters, Inc. All rights reserved.
 * @license     GNU General Public License version 2 or later; see LICENSE.txt
 */

defined('_JEXEC') or die;

$app 	= JFactory::getApplication();
$form 	= $displayData->getForm();

$name 	= $displayData->get('fieldset');
$fieldSet = $form->getFieldset($name);

if (empty($fieldSet))
{
	return;
}

$ignoreFields = $displayData->get('ignore_fields') ? : array();

if ($displayData->get('show_options', 1))
{
	$html = array();

	foreach ($fieldSet as $field)
	{
		$label 	= JLayoutHelper::render( 'joomla.arkfme.form.label', array( 'field' => $field ) );
		$input 	= JLayoutHelper::render( 'joomla.arkfme.form.field', array( 'field' => $field, 'form' => $form ) );
		$html[] = '<div class="ark-form-row">
						' . $label . '
						' . $input . '
					</div>'; 
	}

	echo implode('', $html);
}
else
{
	$html = array();
	$html[] = '<div class="ark-hidden">';
	foreach ($fieldSet as $field)
	{
		$html[] = $field->input;
	}
	$html[] = '</div>';

	echo implode('', $html);
}