<?php

defined( '_JEXEC' ) or die;

// Get field
$field 	= $displayData['field'];
$css	= 'ark-form-label ark-text-break';
$tip	= "{pos : 'right', cls : 'arkfme-tooltip', offset : 0}";

// Valid field, Plain Text or JForm Field?
if( !$field )
{
	return;
}
elseif( is_string( $field ) )
{
	echo '<label class="' . $css . '" for="">' . $field . '</label>';
}
elseif( is_array( $field ) )
{
	$attrs = array( 'class' => $css );

	if( isset( $field['id'] ) )
	{
		$attrs['id'] = $field['id'];
	}//end if

	if( isset( $field['tooltip'] ) )
	{
		$attrs['data-ark-tooltip'] = $tip;
		$field['title'] = ( $field['title'] ) ? $field['title'] : strip_tags( $field['text'] );
		$attrs['title'] = '<strong>' . $field['title'] . '</strong><br />' . $field['tooltip'];
	}//end if

	echo '<label ' . JArrayHelper::toString( $attrs ) . '>' . $field['text'] . '</label>';
}
elseif( is_object( $field ) )
{
	// Retrieve existing classes
	$class 	= $field->__get( 'labelclass' );

	// Add our classes to the label
	$field->__set( 'labelclass', ( $class ? $class . chr( 32 ) . $css : $css ) );

	// Get HTML
	$html 	= $field->label;
	$old	= array();
	$new	= array();
	$type 	= strtolower( $field->type );

	// Extra field specific logic
	switch( $type )
	{
		case 'spacer' :
			// Style spacers and prevent them from expanding
			$old[]	= 'class=""';
			$new[]	= 'class="ark-alert ark-text-break"';
			// Add Close Button
			$old[]	= '</label>';
			$new[]	= '<a href="javascript:void(0);" class="ark-alert-close ark-close"></a></label>';
			// Add Close Button JS Logic
			$old[]	= 'ark-text-break"';
			$new[]	= 'ark-text-break" data-ark-alert';
			break;
	}//end switch

	// Switch bootstrap tooltip
	$old[]	= 'hasTooltip';
	$new[]	= '';

	// Add UIKit tooltip (let CSS calc offset)
	$old[]	= 'title="';
	$new[]	= 'data-ark-tooltip="' . $tip . '" title="';

	// Customise HTML
	$html 	= str_replace( $old, $new, $html );

	// Render label
	echo $html;
}//end if