<?php
/**
 * @package     Joomla.Site
 * @subpackage  Layout
 *
 * @copyright   Copyright (C) 2005 - 2015 Open Source Matters, Inc. All rights reserved.
 * @license     GNU General Public License version 2 or later; see LICENSE.txt
 */

defined('_JEXEC') or die;

$app 		= JFactory::getApplication();
$form 		= $displayData->getForm();
$fieldSets	= $form->getFieldsets();
$lang		= JFactory::getLanguage();

if (empty($fieldSets))
{
	return;
}

$ignoreFieldsets = $displayData->get('ignore_fieldsets') ?: array();

if( $form->getField( 'alias' ) )
{
	// These are required to preserve data on save when fields are not displayed.
	$hiddenFieldsets = $displayData->hiddenFieldsets ?: array();
}

if ($displayData->get('show_options', 1))
{
	foreach ($fieldSets as $name => $fieldSet)
	{
		// Ensure any fieldsets we don't want to show are skipped (including repeating formfield fieldsets)
		if (in_array($name, $ignoreFieldsets) || (isset($fieldSet->repeat) && $fieldSet->repeat == true)
		)
		{
			continue;
		}

		if (!empty($fieldSet->label))
		{
			if( $lang->hasKey( $fieldSet->label ) )
			{
				$label = JText::_($fieldSet->label, true);
			}
			else
			{
				// Fallback title
				$label = JText::_( 'PLG_SYSTEM_ARKFME_OPTIONS_TTL' );
			}//end if
		}
		else
		{
			$label = strtoupper('JGLOBAL_FIELDSET_' . $name);
			if (JText::_($label, true) == $label)
			{
				$label = strtoupper($app->input->get('option') . '_' . $name . '_FIELDSET_LABEL');
			}

			// Fallback title
			if( !$lang->hasKey( $label ) )
			{
				$label = 'PLG_SYSTEM_ARKFME_OPTIONS_TTL';
			}//end if

			$label = JText::_($label, true);
		}

		echo JLayoutHelper::render( 'joomla.arkfme.accordion.title', array( 'title' => $label, 'name' => $name ) );

		echo '<div class="ark-accordion-content">
				<fieldset class="ark-form-stacked">';
		$displayData->fieldset = $name;
		echo JLayoutHelper::render('joomla.arkfme.form.fieldset', $displayData);
		echo  '	</fieldset>
			</div>';
	}
}
else
{
	$html   = array();
	$html[] = '<div class="ark-hidden">';
	foreach ($fieldSets as $name => $fieldSet)
	{
		if (in_array($name, $ignoreFieldsets))
		{
			continue;
		}

		if (in_array($name, $hiddenFieldsets))
		{
			foreach ($form->getFieldset($name) as $field)
			{
				echo $field->input;
			}
		}
	}
	$html[] = '</div>';

	echo implode('', $html);
}