<?php

JLayoutHelper::render( 'joomla.arkfme.language' );

JHtml::_('behavior.formvalidator');
JHtml::_('formbehavior.chosen', 'select');

$document = JFactory::getDocument();
$document->addStyleSheet(JURI::base() . 'plugins/system/arkfme/assets/uikit/css/uikit.min.css');
$document->addStyleSheet(JURI::base() . 'plugins/system/arkfme/assets/uikit/css/components/accordion.min.css');
$document->addStyleSheet(JURI::base() . 'plugins/system/arkfme/assets/uikit/css/components/tooltip.min.css');
$document->addStyleSheet(JURI::base() . 'plugins/system/arkfme/assets/arkit/css/arkit.min.css');
$document->addStyleSheet(JURI::base() . 'plugins/system/arkfme/assets/nano/css/nanoscroller.css');
$document->addScript(JURI::base() . 'plugins/system/arkfme/assets/uikit/js/uikit.min.js');
$document->addScript(JURI::base() . 'plugins/system/arkfme/assets/uikit/js/uikit.noconflict.js');
$document->addScript(JURI::base() . 'plugins/system/arkfme/assets/arkit/js/offcanvas.min.js');
$document->addScript(JURI::base() . 'plugins/system/arkfme/assets/uikit/js/components/accordion.min.js');
$document->addScript(JURI::base() . 'plugins/system/arkfme/assets/arkit/js/togglecaret.js');
$document->addScript(JURI::base() . 'plugins/system/arkfme/assets/uikit/js/components/tooltip.min.js');
$document->addScript(JURI::base() . 'plugins/system/arkfme/assets/nano/js/jquery.nanoscroller.min.js');

$document->addScriptDeclaration("
(function($)
{
	$(document).ready(function()
	{
		if($('.ark-accordion'))
		{
			if( typeof MooTools != 'undefined')
			{
				Element.prototype.hide = function() { return; };
			}
		}
	})
})(jQuery)
");

// Add text entries to runtime for JS logic
JText::script( 'JGLOBAL_USE_GLOBAL', true );
JText::script( 'PLG_SYSTEM_ARKFME_GLOBAL_OPT', true );
?>
<style>

/* Radio Button Groups */
 #ark-fme-offcanvas .radio.btn-group input[type=radio] {
  display: none;
}

#ark-fme-offcanvas input#jform_request_id_name, 
#ark-fme-offcanvas input#jform_params_menu_image {
	width: 50%;
}	
	
</style>
<script>

(function($)
{
	$( document ).ready(function()
	{
		$("#ark-fme-form-offcanvas").submit(function(e) 
		{
			$.ajax(
			{
				type: "POST",
				url: $(this).attr("action"),
				data: $(this).serialize(), // serializes the form's elements.
				success: function(response)
				{
					
                    // Has the server returned a Fatal error or something unusable?
					if( typeof response !== 'object' )
					{
						response = { message : '<?php echo JText::_( 'PLG_SYSTEM_ARKFME_AJAXFAIL_MSG' ); ?>' };
					}//end if

					var warningTypeCls = "ark-alert-danger";

					if(response.success)
					{
						warningTypeCls = "ark-alert-success";
						message = response.data.message;
                        var menuid = response.data.id;
                        var form = $("#ark-fme-form-offcanvas");
                        var fieldid = form.find('#jform_id');
           
                        if(fieldid.val() == 0) 
                        {     
                            fieldid.val(menuid);
                            form.find('.ark-fme-field-id span.ark-fme-field-value').text(menuid);
							if( !form.find('.ark-fme-field-id span.ark-badge').hasClass('ark-hidden'))	
								form.find('.ark-fme-field-id span.ark-badge').addClass('ark-hidden');
							if( !form.find('#ark-fme-btn-save').hasClass('ark-hidden'))
								form.find('#ark-fme-btn-save').addClass('ark-hidden');
                            form.find('#ark-fme-save').removeClass('ark-hidden');    
                            $(form[0].elements.namedItem('menuid')).val(menuid);  
                         }       
					}
					else
						message = response.message;

					$("#ark-fme-msg").append('<div class="ark-alert '+warningTypeCls+'" data-ark-alert>'
						+'<a href="javascript:void(0);" class="ark-alert-close ark-close"></a>'
						+'<p>'+message+'</p>'
						+'</div>').toggleClass("ark-hidden");

					$("#ark-fme-msg a.ark-alert-close").on("click", function(e)
					{
						$(this).parent().parent().toggleClass("ark-hidden");
						$(this).parent().remove();
						e.preventDefault();
					});
				},
				error: function(xhr)
				{
					console.log(xhr.responseText); // @text = response error, it is will be errors: 324, 500, 404 or anythings else
				}
			});

			e.preventDefault(); // avoid to execute the actual submit of the form.
		});

		// On offcanvas open initialise canvas logic
		$( '.ark-offcanvas-bar' ).on( 'show.uk.offcanvas', function()
		{
			$.fn.ark.canvas.every();
		});

		// Initialise basic canvas logic
		$.fn.ark.canvas.once();
	});

	if($("#jform_catid").length)
	{	
		$("#jform_catid").on('change',  function(e) 
			{
				var value = $(this).val();
				 
				$(this.form.elements.namedItem('type')).val(value);
				 
				$.ajax({
						type: "POST",
						url: "<?php echo JURI::base();?>index.php?option=com_arkfme&plugin=arkfme&format=json&catid="+value,

						data: $("#ark-fme-form-offcanvas").serialize(), // serializes the form's elements.
						success: function(response)
						{
						   $("#ark-fme-form-offcanvas").html(response);	  
						},
						error: function(xhr) {
						console.log(xhr.responseText); // @text = response error, it is will be errors: 324, 500, 404 or anythings else
						}
				});

				e.preventDefault(); // avoid to execute the actual submit of the form.
			});
	}
})(jQuery);
</script>
<form class="ark-form" id="ark-fme-form-offcanvas" name="ark-fme-form-offcanvas" action="<?php echo JURI::base().'index.php?option=com_ajax&plugin=arkfme&format=json&a_id='. JFactory::getApplication()->input->get('a_id',0); ?>" data-ark-observe>
<?php

	$displayData->ignore_fieldsets = array('aliasoptions', 'request', 'item_associations');

	echo JLayoutHelper::render('joomla.arkfme.form.form', $displayData);
?>
</form>